#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"
#include "editor.h"

#include <string.h>

#include <gtkhtml/gtkhtml.h>
GtkWidget * html_widget;

GtkWidget*
Html_create (gchar *widget_name, gchar *string1, gchar *string2,
                gint int1, gint int2)
{
	html_widget = gtk_html_new();
	//GtkHTMLStream * handle = gtk_html_begin(GTK_HTML(html_widget));
	gtk_html_begin(html_widget);
 	gtk_html_load_empty (GTK_HTML (html_widget));
 	gtk_html_set_editable (GTK_HTML (html_widget), TRUE);
	//gtk_html_set_animate (GTK_HTML (html_widget), FALSE);
 
 	//cd = gtk_html_control_data_new (GTK_HTML (html_widget), vbox);
return (html_widget);
}

gboolean
on_dialoglite_delete_event             (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_main_quit ();
  return FALSE;
}

void
on_toolbtnCut_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_cut(GTK_HTML (html_widget));
}


void
on_toolbtnCopy_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_copy(GTK_HTML (html_widget));
}


void
on_toolbtnPaste_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_paste(GTK_HTML (html_widget), TRUE);
}


void
on_toolbtnEditorDelete_clicked         (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

}


void
on_toolbtnClear_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{

}


void
on_toolbtnUndo_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_undo(GTK_HTML (html_widget));
}


void
on_toolbtnRedo_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_redo(GTK_HTML (html_widget));
}


void
on_toolbtnBold_clicked                 (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_toggle_font_style(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_BOLD);
}


void
on_toolbtnItalic_clicked               (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_toggle_font_style(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_ITALIC);
}


void
on_toolbtnUnder_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_toggle_font_style(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_UNDERLINE);
}


void
on_toolbtnStrike_clicked               (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_toggle_font_style(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_STRIKEOUT);
}


void
on_toolbtnSuper_clicked                (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
//html_style_set_decoration(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_SUPERSCRIPT);
gtk_html_toggle_font_style(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_SUPERSCRIPT);
}


void
on_toolbtnSub_clicked                  (GtkToolButton   *toolbutton,
                                        gpointer         user_data)
{
gtk_html_toggle_font_style(GTK_HTML (html_widget), GTK_HTML_FONT_STYLE_SUBSCRIPT);
}

static gboolean
save_receiver (const HTMLEngine *engine,
	       const gchar *data,
	       guint length,
	       gpointer user_data)
{
	printf("works:\n");

	return TRUE;
}
char * html_string;
static gboolean
libbalsa_html_receiver_fn(const HTMLEngine * engine, const gchar * data, guint len,
			  GString  export_string)
{
   strcat(html_string, data);
   return TRUE;
}


void
on_okbutton1_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
char html_buf[12000] = "";
html_string = html_buf;
GString * export_string = g_string_new("");
gtk_html_export(GTK_HTML(html_widget), "text/html",
			(GtkHTMLSaveReceiverFn) libbalsa_html_receiver_fn,
			&export_string);
printf("data:%s\n", html_string);
}


//gboolean  gtk_html_export  (GtkHTML               *html,
//			    const char            *type,
//			    GtkHTMLSaveReceiverFn  receiver,
//			    gpointer               data);
